#include "gbox_gfx.h"
#include <stdio.h>

GboxImage *
gbox_gfx_new(char* filename, GtkWidget *widget)
{
  GboxImage *image = g_new(GboxImage, 1);
  
  image->pixbuf = gdk_pixbuf_new_from_file(filename);
  image->file = g_strdup(filename);
  
  image->widget = widget;

  return image;
}

void
gbox_gfx_free(GboxImage* image)
{
  gdk_pixbuf_unref(image->pixbuf);
  g_free(image->file);

  g_free(image);
}

gchar *
gbox_gfx_file(GboxImage* image)
{
  return image->file;
}

void
gbox_gfx_set_widget(GboxImage* image, GtkWidget *widget)
{
  image->widget = widget;
}

void
gbox_gfx_draw(GboxImage *image)
{

  if (gtk_object_get_data(GTK_OBJECT(image->widget), "pixbuf"))
    gtk_object_remove_data (GTK_OBJECT(image->widget), "pixbuf");
  gtk_drawing_area_size (GTK_DRAWING_AREA(image->widget),
			 gdk_pixbuf_get_width(image->pixbuf),
			 gdk_pixbuf_get_height(image->pixbuf));
  gtk_object_set_data (GTK_OBJECT(image->widget), "pixbuf", image->pixbuf);
}

void
gbox_gfx_change(GboxImage *image, char* filename)
{
  gdk_pixbuf_unref(image->pixbuf);
  
  g_free(image->file);
  image->file = g_strdup(filename);
  image->pixbuf = gdk_pixbuf_new_from_file(filename);
  gtk_object_set_data (GTK_OBJECT(image->widget), "pixbuf", image->pixbuf);
}

int
gbox_gfx_width(GboxImage* image)
{
  return gdk_pixbuf_get_width(image->pixbuf);
}

int
gbox_gfx_height(GboxImage* image)
{
  return gdk_pixbuf_get_height(image->pixbuf);
}

void
gbox_gfx_expose(GboxImage *image, void (*expose_func)(GtkWidget *, GdkEventExpose *, gpointer))
{
  GdkEventExpose expose;
  
  expose.area.x = expose.area.y = 0;
  expose.area.height = gbox_gfx_height(image);
  expose.area.width = gbox_gfx_width(image);
  expose_func(image->widget, &expose, NULL);
}

  



