#ifndef GBOX_GFX_H
#define GBOX_GFX_H

#include "gbox_mailbox.h"
#include <gtk/gtk.h>
#include <gdk/gdk.h>
#include <gdk-pixbuf/gdk-pixbuf.h>

typedef struct _gbox_image GboxImage;

struct _gbox_image {
  GtkWidget *widget;
  GdkPixbuf *pixbuf;
  gchar     *file;
};


GboxImage *gbox_gfx_new(gchar* filename, GtkWidget *widget);
void gbox_gfx_free(GboxImage* image);
gchar *gbox_gfx_file(GboxImage* image);
void gbox_gfx_set_widget(GboxImage* image, GtkWidget *widget);
void gbox_gfx_change(GboxImage* image, gchar* filename);
void gbox_gfx_draw(GboxImage *image);
int gbox_gfx_width(GboxImage* image);
int gbox_gfx_height(GboxImage* image);
void gbox_gfx_expose(GboxImage *image, 
		     void (*expose_func)(GtkWidget *, GdkEventExpose *, gpointer));

#endif
